Subject: Re: [PATCH] net: ethernet: ti: cpsw_ale: optimize cpsw_ale_restore()

From: Jakub Kicinski <[email-masked]>
Date: Thu, 10 Nov 2022 12:32:49 -0800

On Thu, 10 Nov 2022 11:39:47 +0200 Roger Quadros wrote:
> > Maybe my tree is old but I see we clear only if there is a netdev that  
> 
> This patch depends on this series
> https://lore.kernel.org/netdev/[email-masked]/T/

I do have those in my tree.

> > needs to be opened but then always call ale_restore(). Is that okay?  
> 
> If netdev is closed and opened ale_restore() is not called.
> ale_restore() is only called during system suspend/resume path
> since CPSW-ALE might have lost context during suspend and we want to restore
> all valid ALE entries.

Ack, what I'm referring to is the contents of am65_cpsw_nuss_resume().

I'm guessing that ALE_CLEAR is expected to be triggered by
cpsw_ale_start().

Assuming above is true and that ALE_CLEAR comes from cpsw_ale_start(),
the call stack is:

 cpsw_ale_start()
 am65_cpsw_nuss_common_open()
 am65_cpsw_nuss_ndo_slave_open()
 am65_cpsw_nuss_resume()

but resume() only calls ndo_slave_open under certain conditions:

        for (i = 0; i < common->port_num; i++) {                                  
                if (netif_running(ndev)) {                                      
                        rtnl_lock();                                            
                        ret = am65_cpsw_nuss_ndo_slave_open(ndev);    

Is there another path? Or perhaps there's nothing to restore 
if all netdevs are down?

> I have a question here. How should ageable entries be treated in this case?

Ah, no idea :) Let's me add experts to To: